using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;  

namespace GGC_UseGDI
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private bool UseGDI;
        private void Form1_Load(object sender, EventArgs e)
        {
            #region Get the DataSource
            DataTable dt = new DataTable("MyTable");

            int nCols = 4;
            int nRows = 1000;

            for (int i = 0; i < nCols; i++)
                dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(string)));

            Random r = new Random();
            for (int i = 0; i < nRows; ++i)
            {
                DataRow dr = dt.NewRow();
                for (int j = 0; j < nCols; j++)
                    dr[j] = string.Format("row{0}col{1}",i,j) ;
                dt.Rows.Add(dr);
            }
            #endregion
            this.gridGroupingControl1.DataSource = dt;

            //this.gridGroupingControl1.TableControlDrawCellDisplayText += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellDisplayTextEventHandler(gridGroupingControl1_TableControlDrawCellDisplayText);
            this.gridGroupingControl1.TableControlDrawCell += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellEventHandler(gridGroupingControl1_TableControlDrawCell);
        }

        void gridGroupingControl1_TableControlDrawCell(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlDrawCellEventArgs e)
        {
            if (UseGDI && e.Inner.Style.CellType == "TextBox")
                e.Inner.Cancel = GridGdiPaint.Instance.DrawText(e.Inner.Graphics, e.Inner.Style.Text, e.Inner.Bounds, e.Inner.Style);                           
        }
        
        private void button1_Click(object sender, EventArgs e)
        {
            UseGDI = true;
            this.gridGroupingControl1.TableControl.Refresh(); 
        }
    }
}